#include <stdio.h>
#include "tx.h"

/******************************************************************************
ڴؿ̾	checksum()
ڵǽ	Ĥʸ󤫤顢å׻
ڰ	ʸġ
͡	åࡣ
ա	δؿƤФؿޤޤƤޤ
			⡢ۤȤɱ¼ɧˤäƽ񤫤줿Ρ
******************************************************************************/

#define CRCPOLY 0xedb88320UL	/* Ѥʤ */
#define SECRET	0x87654321UL	/* Ǥդ unsigned long ο */

static unsigned long crctable[256];

static void makecrctable(void)
{
	unsigned int i, j;
	unsigned long r;

	for (i = 0; i < 256; i++) {
		r = i;
		for (j = 0; j < 8; j++)
			if (r & 1) r = (r >> 1) ^ CRCPOLY;
			else	   r >>= 1;
		crctable[i] = r;
	}
}

static unsigned long crc32(unsigned char *s)
{
	unsigned long r;

	r = SECRET;
	while (*s) {
		r = (r >> 8) ^ crctable[(unsigned char)r ^ *s++];
	}
	return r;
}

unsigned long checksum(char *s, char *p)
{
	static int initialized = 0;

	if (! initialized) {
		initialized = 1;
		makecrctable();
	}
	if (p == NULL) {
		return crc32((unsigned char *)s);
	} else {
		return crc32((unsigned char *)s) ^ crc32((unsigned char *)p);
	}
}
